using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MJPEGDecoder
{
    public partial class Form1 : Form
    {
        MJPEGDecodeAndDisplay decoder;
        WebcamControl control = new WebcamControl();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            addressTxt.Text = Properties.Settings.Default.address;
            portTxt.Text = Properties.Settings.Default.port;
        }

        private void connectButton_Click(object sender, EventArgs e)
        {
            decoder = new MJPEGDecodeAndDisplay(addressTxt.Text+":"+portTxt.Text+"/?action=stream");
            decoder.Picture += new MJPEGDecodeAndDisplay.PictureEventHandler(decoder_Picture);
            decoder.FPS += new MJPEGDecodeAndDisplay.FPSEventHandler(decoder_FPS);
            try
            {
                decoder.start();
                control.setReady(addressTxt.Text, portTxt.Text);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error: " + ex.Message);
            }
        }

        void decoder_FPS(object sender, MJPEGDecodeAndDisplay.FPSEventArgs e)
        {
            fpsLabel.Text = e.fps.ToString();
        }

        void decoder_Picture(object sender, MJPEGDecodeAndDisplay.PictureEventArgs e)
        {
            webcamView.Image = e.picture;
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            try
            {
                decoder.stop();
                Properties.Settings.Default.address = addressTxt.Text;
                Properties.Settings.Default.port = portTxt.Text;
                Properties.Settings.Default.Save();
            }
            catch { }
        }

        //maintain 4x3 aspect ratio
        private void webcamView_Resize(object sender, EventArgs e)
        {
            int height = (int)Math.Round(webcamView.Size.Width * 3 / 4.0);
            webcamView.Size = new Size(webcamView.Size.Width, height);
            this.MinimumSize = new System.Drawing.Size(this.MinimumSize.Width, height+34); //34 for border/toolbar
        }

        private void stopButton_Click(object sender, EventArgs e)
        {
            decoder.stop();
            control.setNotReady();
        }

        private void webcamControlButton_Click(object sender, EventArgs e)
        {
            control.Show();
        }
    }
}