using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;

namespace MJPEGDecoder
{
    public partial class WebcamControl : Form
    {

        String address="", port="";

        public WebcamControl()
        {
            InitializeComponent();
        }

        private void WebcamControl_FormClosing(object sender, FormClosingEventArgs e)
        {

            if (e.CloseReason == CloseReason.UserClosing)
            {
                Hide();
                e.Cancel = true;
            }
        }

        public void setReady(String addr, String port)
        {
            this.address = addr;
            this.port = port;

            brightMinusBtn.Enabled = true;
            brightPlusBtn.Enabled = true;
            contrastMinusBtn.Enabled = true;
            contrastPlusBtn.Enabled = true;
            satMinusBtn.Enabled = true;
            satPlusBtn.Enabled = true;
            gainMinusBtn.Enabled = true;
            gainPlusBtn.Enabled = true;
            focusMinusBtn.Enabled = true;
            focusPlusBtn.Enabled = true;
            focusSlider.Enabled = true;
            resetPicBtn.Enabled = true;
            tiltUpBtn.Enabled = true;
            tiltDownBtn.Enabled = true;
            panRightBtn.Enabled = true;
            panLeftBtn.Enabled = true;
            panSlider.Enabled = true;
            tiltSlider.Enabled = true;
            resetPanTiltBtn.Enabled = true;
        }

        public void setNotReady()
        {
            brightMinusBtn.Enabled = false;
            brightPlusBtn.Enabled = false;
            contrastMinusBtn.Enabled = false;
            contrastPlusBtn.Enabled = false;
            satMinusBtn.Enabled = false;
            satPlusBtn.Enabled = false;
            gainMinusBtn.Enabled = false;
            gainPlusBtn.Enabled = false;
            focusMinusBtn.Enabled = false;
            focusPlusBtn.Enabled = false;
            focusSlider.Enabled = false;
            resetPicBtn.Enabled = false;
            tiltUpBtn.Enabled = false;
            tiltDownBtn.Enabled = false;
            panRightBtn.Enabled = false;
            panLeftBtn.Enabled = false;
            panSlider.Enabled = false;
            tiltSlider.Enabled = false;
            resetPanTiltBtn.Enabled = false;
        }

        //can probably keep a stream open for commands
        public void sendCommand(string command)
        {
            sendCommand(command, "");
        }
        public void sendCommand(string command, string val)
        {
            HttpWebRequest req = null;
            HttpWebResponse resp = null;
            string commandAddress = "http://" + address + ":" + port + "/?action=command&command=" + command;
            if (val != "")
                commandAddress = commandAddress + "&value=" + val;
            statusLbl.Text = "Sending command...";
            statusLbl.ForeColor = Color.Black;
            Application.DoEvents();
            try
            {
                req = (HttpWebRequest)WebRequest.Create(commandAddress);
                resp = (HttpWebResponse)req.GetResponse();
                Stream dataStream = resp.GetResponseStream();
                StreamReader reader = new StreamReader(dataStream);
                string responseFromServer = reader.ReadToEnd();

                reader.Close();
                dataStream.Close();
                resp.Close();

                if (responseFromServer.EndsWith("0"))
                {
                    statusLbl.Text = "Done";
                    statusLbl.ForeColor = Color.Black;
                }
                else
                {
                    statusLbl.Text = "Failed";
                    statusLbl.ForeColor = Color.Red;
                }
            }
            catch
            {
                statusLbl.Text = "Error.";
            }
        }

        private void brightPlusBtn_Click(object sender, EventArgs e)
        {
            sendCommand("brightness_plus");
        }

        private void brightMinusBtn_Click(object sender, EventArgs e)
        {
            sendCommand("brightness_minus");
        }

        private void resetPicBtn_Click(object sender, EventArgs e)
        {
            sendCommand("reset");
        }

        private void contrastPlusBtn_Click(object sender, EventArgs e)
        {
            sendCommand("contrast_plus");
        }

        private void contrastMinusBtn_Click(object sender, EventArgs e)
        {
            sendCommand("contrast_minus");
        }

        private void satPlusBtn_Click(object sender, EventArgs e)
        {
            sendCommand("saturation_plus");
        }

        private void satMinusBtn_Click(object sender, EventArgs e)
        {
            sendCommand("saturation_minus");
        }

        private void gainPlusBtn_Click(object sender, EventArgs e)
        {
            sendCommand("gain_plus");
        }

        private void gainMinusBtn_Click(object sender, EventArgs e)
        {
            sendCommand("gain_minus");
        }

        private void focusPlusBtn_Click(object sender, EventArgs e)
        {
            sendCommand("focus_plus");
        }

        private void focusMinusBtn_Click(object sender, EventArgs e)
        {
            sendCommand("focus_minus");
        }

        private void focusSlider_Scroll(object sender, EventArgs e)
        {
            sendCommand("focus_set", (focusSlider.Value*10).ToString());
        }

        private void tiltUpBtn_Click(object sender, EventArgs e)
        {
            sendCommand("tilt_minus");
        }

        private void tiltDownBtn_Click(object sender, EventArgs e)
        {
            sendCommand("tilt_plus");
        }

        private void panLeftBtn_Click(object sender, EventArgs e)
        {
            sendCommand("pan_plus");
        }

        private void panRightBtn_Click(object sender, EventArgs e)
        {
            sendCommand("pan_minus");
        }

        private void panSlider_Scroll(object sender, EventArgs e)
        {
            sendCommand("pan_set", (-panSlider.Value*10).ToString());
        }

        private void tiltSlider_Scroll(object sender, EventArgs e)
        {
            sendCommand("tilt_set", (-tiltSlider.Value*10).ToString());
        }

        private void resetPanTiltBtn_Click(object sender, EventArgs e)
        {
            sendCommand("reset_pan_tilt");
        }

    }
}